## aspectc++ 0.99+1.0pre3

=== Ag++/Makefile ===
# ******************************
# *       S E T T I N G S      *
# ******************************


# PUMA root
PUMA    ?= ../Puma

# default target
TARGET  ?= linux-release

#AspectC++ source directory
AC_SRC_DIR := ../AspectC++

# include the PUMA configuration variables
# => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
include $(PUMA)/vars.mk

#CXX  := /usr/bin/g++-3.3
#CXX := ag++  -p. -p../aspects --Xcompiler

# compiler settings
ifeq ($(_TARGET),win32)
        CXXFLAGS += -I $(PUMA)/src/win32/regex
	EXT :=.exe
	RES := mingw32-windres
endif

CXXFLAGS += $(CPPFLAGS) -I$(PUMA)/include
ifneq ($(_TARGET),macosx)
	ifeq ($(SHARED),)
		LDFLAGS += -static
	endif

LDFLAGS += -Wl,-Bstatic -L$(PUMA)/lib/$(TARGET) -lPuma

ifneq ($(SHARED),)
LDFLAGS += -Wl,-Bdynamic
endif

endif

ifneq ($(PROFILING),)
	LDFLAGS += -lc_p -lm_p 
	CXXFLAGS += -pg
endif

# ******************************
# *       S O U R C E S        *
# ******************************

BINDIR := bin/$(TARGET)
PROG := $(BINDIR)/ag++$(EXT)

CCSOURCES := $(wildcard *.cc) 

OBJECTDIR := ObjFiles/$(TARGET)
OBJECTS := $(addprefix $(OBJECTDIR)/,$(CCSOURCES:%.cc=%.o))

DEPDIR := DepFiles/$(TARGET)
DEPS := $(addprefix $(DEPDIR)/,$(CCSOURCES:%.cc=%.d))

ifeq ($(_TARGET),win32)
RCFILES := win-ag++.rc
OBJECTS += $(addprefix $(OBJECTDIR)/,$(RCFILES:%.rc=%.o))
DEPS += $(addprefix $(DEPDIR)/,$(RCFILES:%.rc=%.d))
endif


DIRS := $(OBJECTDIR) $(DEPDIR) $(BINDIR)



# ******************************
# *     T A R G E T S          *
# ******************************

all: showtarget dirs $(AC_SRC_DIR)/$(PROG)

showtarget:
	@echo "---"
	@echo "Making AspectC++ for TARGET=$(TARGET)"
	@echo "  AC++     = $(ACXX) $(ACXXFLAGS) <objects> "
	@echo "  Compiler = $(CXX) $(CXXFLAGS)"
	@echo "  Linker   = $(CXX) $(CXXFLAGS) <objects> $(LDFLAGS)"
	@echo "---"

clean: 
	@echo -n "CLEAN    "
	rm -rf $(PROG) core core.* *~ $(DIRS)

cleanalltarget:
	rm -rf $(DIRS)


test:	all
	@export TARGET=$(TARGET);export _TARGET=$(_TARGET);export EXT=$(EXT);cd tests;./run_tests.sh

test_%: all
	@export TARGET=$(TARGET);export _TARGET=$(_TARGET);export EXT=$(EXT);cd tests; ./run_tests.sh $@


dirs:  $(DIRS)


.PHONY: all clean showtarget dirs 

# ******************************
# *       R U L E S            *
# ******************************

$(PROG): $(OBJECTS) 
	@echo "LD        $@"
	@$(CXX) -o $@ $^ $(LDFLAGS)

$(AC_SRC_DIR)/bin/$(TARGET):
	@mkdir -p $@

$(AC_SRC_DIR)/$(PROG): $(PROG) $(AC_SRC_DIR)/bin/$(TARGET)
	@echo "COPY      $< to $@"
	@cp $< $@

$(OBJECTDIR)/%.o : %.cc 
	@echo "CC        $@"
	@$(CXX) $(CXXFLAGS) -c -o $@ $<

ifeq ($(_TARGET),win32)
$(OBJECTDIR)/%.o : %.rc
	@echo "RES       $@"
	@$(RES) $(filter -D%,$(CXXFLAGS)) $< $@

$(DEPDIR)/%.d: %.rc
	@echo "DEP       $@."
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CXXFLAGS) -MM -MT $(OBJECTDIR)/$(notdir $(@:%.d=%.o)) -MT $@  -MF $@ -xc++ $< 
endif

$(DEPDIR)/%.d: %.cc 
	@echo "DEP       $@."
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CXXFLAGS) -MM -MT $(OBJECTDIR)/$(notdir $(@:%.d=%.o)) -MT $@ -MF $@ $< 

$(DIRS):
	@mkdir -p $@


ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

.SUFFIXES: .cc .o .h .rc .mk $(SUFFIXES)

=== AspectC++/Makefile ===
# ******************************
# *       S E T T I N G S      *
# ******************************

# PUMA root
PUMA    ?= ../Puma

# default target
TARGET  ?= linux-release

# include the PUMA configuration variables
# => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
include $(PUMA)/vars.mk

# libxml2 settings
ifeq ($(_TARGET),win32)
	LIBXML2_INC := `mingw32-xml2-config --cflags` 
	LIBXML2_LIB := `mingw32-xml2-config --libs` -lwsock32
	EXT=.exe
else
	LIBXML2_INC := `xml2-config --cflags` 
	LIBXML2_LIB := `xml2-config --libs` 
endif

# linker settings
ifneq ($(_TARGET),macosx)
        ifeq ($(SHARED),)
                LDFLAGS += -static
        endif
	LDFLAGS += -Wl,-Bstatic -L$(PUMA)/lib/$(TARGET) -lPuma 
ifneq ($(SHARED),)
	LDFLAGS += -Wl,-Bdynamic
endif
endif

LDFLAGS += $(LIBXML2_LIB)

# compiler settings
ifeq ($(_TARGET),win32)
        CPPFLAGS += -I $(PUMA)/src/win32/regex
	RES := mingw32-windres
	RCFILES := win-ac++.rc
endif

CPPFLAGS += -I$(PUMA)/include $(LIBXML2_INC)

# profiling
ifneq ($(PROFILING),)
	LDFLAGS := $(LDFLAGS) -lc_p -lm_p 
	CXXFLAGS += -pg
endif





# ******************************
# *       S O U R C E S        *
# ******************************

BINDIR := bin/$(TARGET)

#programm to compile
PROG := $(BINDIR)/ac++$(EXT)

CCSOURCES := $(wildcard *.cc) 

OBJECTDIR := ObjFiles/$(TARGET)
OBJECTS := $(addprefix $(OBJECTDIR)/,$(CCSOURCES:.cc=.o) $(RCFILES:.rc=.o))

DEPDIR := DepFiles/$(TARGET)
DEPS := $(addprefix $(DEPDIR)/,$(CCSOURCES:.cc=.d))

DIRS := $(OBJECTDIR) $(DEPDIR) $(BINDIR)

# ******************************
# *  E X A M P L E  / T E S T  *
# ******************************

# tool selection
export AC := $(shell pwd)/$(PROG)
MAKE ?= make

# ac++ settings for tests
ACFLAGS := -v 9

ACEXAMPLES = FigureObserver Instances Trace CFlow ID Action Cache IconCache \
	     Order


.PHONY: $(ACEXAMPLES) 


# ******************************
# *      T A R G E T S         *
# ******************************

all: showtarget dirs $(PROG)

showtarget:
	@echo "---"
	@echo "Making AspectC++ for TARGET=$(TARGET)"
	@echo "  Compiler = $(CXX) $(CPPFLAGS) $(CXXFLAGS)"
	@echo "  Linker   = $(CXX) $(CXXFLAGS) <objects> $(LDFLAGS)"
	@echo "---"




clean:  testclean exampleclean
	@echo Making it clean.
	@rm -rf  core core.* *~ $(PROG) $(OBJECTDIR) $(DEPDIR) $(ERROR_FILE)

dirs: $(DIRS)

test: $(PROG)$(EXT) testall

example: $(PROG)$(EXT) $(addsuffix .example_make, $(ACEXAMPLES))

examplerun: example $(addsuffix .example_run, $(ACEXAMPLES))

exampleclean:
	@rm -rf examples/*-out
	@rm -rf examples/*.acp

.PHONY: all test  clean  example  examplerun  exampleclean \
        showtarget



# ******************************
# *       R U L E S            *
# ******************************




$(DIRS) :
	@mkdir -p $@



$(PROG): $(OBJECTS)
	@echo "Linking $@."
	@$(CXX) -o $@ $(CXXFLAGS) $^ $(LDFLAGS)


$(OBJECTDIR)/%.o : %.cc
	@echo Making object file $@.
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<

# -Wold-style-cast to find classic C casts "a = (A*)b;"

$(DEPDIR)/%.d: %.cc
	@echo Making dependency file $@.
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MM -MT $(OBJECTDIR)/$(<:%.cc=%.o) -MT $@ $< >$@ 

ifeq ($(_TARGET),win32)
$(OBJECTDIR)/%.o : %.rc
	@echo Compiling Windows resource file
	@$(RES) $(filter -D%,$(CPPFLAGS)) $< $@

endif

test%: 
	$(MAKE) -C tests -s  $*

%.example_make: %
	cd examples/$< ; \
	$(AC) $(ACFLAGS) -I. -p . -d ../$<-out \
	-r ../$<.acp ; \
	cp Makefile ../$<-out/Makefile; \
	cd ../..

%.example_run:	%
	@mkdir examples/$<-out || true
	cd examples/$<-out; $(MAKE); `find . -type f -perm -700`

ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

=== Puma/Makefile ===
#-------------------------------------------------
# variables 
#-------------------------------------------------

include files.mk

ROOT    ?= $(shell pwd)
TARGET  ?= linux-release
AC      ?= ac++
PREFIX  ?= /usr/local 

include vars.mk

LIBDIR  := $(ROOT)/lib/$(TARGET)
GENDIR  := $(ROOT)/gen-$(RELEASE)

INCDIR  := $(ROOT)/include
OBJDIR  := $(GENDIR)/obj-$(_TARGET)
STEP1   := $(GENDIR)/step1
STEP2   := $(GENDIR)/step2

CONFIG  := $(GENDIR)/puma.cfg

# exported variables
export GENDIR INCDIR LIBDIR OBJDIR STEP1 STEP2
export ROOT TARGET AC DONTWEAVE CONFIG
export ORASOURCES LEMSOURCES SOURCES ASPECTS 

# suppress reporting directory changes
MAKE := $(MAKE) --no-print-directory

#-------------------------------------------------
# rules
#-------------------------------------------------

all: showinfo src

weave: showinfo src

compile: showinfo src

showinfo:
	@echo 
	@echo "---"
	@echo "Making PUMA for TARGET=$(TARGET)"
	@echo "---"
	@echo 

tools:
	@echo "Making tools..."
	@cd $(ROOT)/tools && $(MAKE)

src: tools
	@echo "Making library..."
	@cd $(ROOT)/src && $(MAKE) $(MAKECMDGOALS)

examples: src
	@echo "Making examples..."
	@cd $(ROOT)/examples && $(MAKE)

doxygen:
	@echo "Making Puma documentation with doxygen..."
	@doxygen doc/doxygen.conf && echo "=> see doc/doxygen/html/index.html"

install: config src
	@echo "Installing library and headers..."
	@cp -pv $(CONFIG) /etc/puma.config
	@cp -pv $(LIBDIR)/libPuma.* $(PREFIX)/lib
	@mkdir -p $(PREFIX)/include/Puma
	@cp -pv $(INCDIR)/Puma/*.*h $(PREFIX)/include/Puma

uninstall: 
	@echo "Uninstalling library and headers..."
	@rm -fv /etc/puma.config
	@rm -fv $(PREFIX)/lib/libPuma.*
	@rm -rfv $(PREFIX)/include/Puma

clean: tools-clean
	@cd $(ROOT)/src && $(MAKE) clean

tools-clean:
	@echo "Making tools clean..."
	@cd $(ROOT)/tools && $(MAKE) -s clean

examples-clean:
	@echo "Making examples clean..."
	@cd $(ROOT)/examples && $(MAKE) -s clean

cleanall: distclean

distclean: clean examples-clean
	@cd $(ROOT)/src && $(MAKE) distclean

libclean:
	@echo "Removing library and object files..."
	@rm -f $(LIBDIR)/libPuma.*
	@rm -rf $(OBJDIR)
	@rm -rf $(STEP2)/dep

#-------------------------------------------------
# targets
#-------------------------------------------------

.PHONY: all tools src install examples distclean cleanall \
clean tools-clean examples-clean libclean weave compile uninstall

=== AspectC++/tests/Makefile ===
ifeq ($(MAKELEVEL),0)
$(error Sorry, this makefile is not intended to be \
used directly. Please use the makefile in the toplevel \
directory of the ApectC++ source tree instead)
endif

ACTESTS = Advice AdviceVirtualFct That StaticTrace Context NameMangling \
          Forward StandAloneCalls UnknownTypeCheck AccessControl Result \
          ArrayMangling MatchExpr ConsDesAdvice NestedClassFuncAdvice \
          MacroCall CallAdvice CallOnRef TemplateExtCall Bug190 Bug191 Bug192 \
	  Order NonInlineIntros JPType PragmaOnce Bug207 Bug209 \
	  AbstractDerivedAspect PragmaOnceObserver ThatConst PrivateResult \
          VoidArg ArrayWrapper Bug216 Bug228 ExecAdviceRecursive ExternC \
	  ThatContext IntroIncludes Bug234 Bug234-2 Bug235 Bug239 \
	  ExecAdviceNewDelete CallPostfixOp STLString CFlowCycle \
	  IntroInBase NonInlineIntroInclude Bug267 Bug268 Bug271 MatchVirtual \
	  PctInClass IntroInAll Instantiation Slice NonInlineSliceInclude \
	  Empty \
	  RepoInvalid RepoVersion

ACMSGTESTS := RepoInvalid RepoVersion

ACNORUN := $(filter $(ACMSGTESTS), $(ACTESTS))

ACRUN   := $(filter-out $(ACNORUN), $(ACTESTS))

STDOUT_FILE := stdout.txt
STDERR_FILE := stderr.txt
ERROR_FILE :=  error.txt

all: $(addsuffix .make, $(ACRUN)) $(addsuffix .weave, $(ACNORUN))
	@if [ -f $(ERROR_FILE) ];then \
		echo -e "\n\n"; \
		echo "+---------+"; \
		echo "|ERRORS:  |"; \
		echo "+---------+"; \
		cat $(ERROR_FILE); \
	 else \
		echo -e "\n\n"; \
	 	echo "All tests OK"; \
	 fi;\
	 rm -f $(STDOUT_FILE) $(STDERR_FILE) $(ERROR_FILE)

ref:  $(addsuffix .ref, $(ACTESTS))

refclean:
	rm */feature.ref

run: $(addsuffix .run, $(ACRUN))

clean: $(addsuffix .clean, $(ACTESTS))


%.weave: %
	@unset LANG; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $</feature.out; \
	exec 2> $</feature.err; \
	$(MAKE) -s EXT="$(EXT)" -C $< ; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	cat $</feature.err >> $</feature.out; \
	rm $</feature.err; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	diff $</feature.out $</feature.ref; \
	RET=$$?; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo -n "."; \
	else \
		ERR_FLAG=D; \
	 	echo -n "[$$ERR_FLAG:$<]"; \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo  -n "TEST: $<" >> $(ERROR_FILE); \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo -e "STDOUT:\n--------" >> $(ERROR_FILE); \
		cat $(STDOUT_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
		echo -e "STDERR:\n--------" >> $(ERROR_FILE); \
		cat $(STDERR_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
	fi;


%.make: %
	@exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $< ; \
	RET=$$?; \
	ERR_FLAG=C; \
	if [ $$RET == 0 ];then \
	 	$(MAKE) -s EXT="$(EXT)" -C $< diff; \
	 	RET=$$?; \
		ERR_FLAG=D; \
	fi; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo -n "."; \
	else \
	 	echo -n "[$$ERR_FLAG:$<]"; \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo  -n "TEST: $<" >> $(ERROR_FILE); \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo -e "STDOUT:\n--------" >> $(ERROR_FILE); \
		cat $(STDOUT_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
		echo -e "STDERR:\n--------" >> $(ERROR_FILE); \
		cat $(STDERR_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
	fi;




%.ref: %
	$(MAKE) -s EXT="$(EXT)" -C $< ref; 

%.run:	%
	cd $< && $(MAKE) run

%.clean: %
	cd $< && $(MAKE) clean

.PHONY: all clean run ref

=== Puma/examples/Makefile ===
#-------------------------------------------------
# variables 
#-------------------------------------------------

SUBDIRS := $(shell find $(shell pwd) -type d -maxdepth 1 -mindepth 1)
SUBDIRS := $(filter-out %/CVS, $(SUBDIRS))
SUBDIRS := $(SUBDIRS)

ifeq ($(SUBDIRS),)

define propagate
endef

else

# define how to propagate a target into the subdirectories
define propagate
	for DIR in $(SUBDIRS); \
	  do cd $$DIR; \
	  $(MAKE) $(MAKECMDGOALS); \
	done
endef

endif

#-------------------------------------------------
# rules
#-------------------------------------------------

all clean:
	@$(propagate)

=== Puma/src/Makefile ===
ifeq ($(MAKELEVEL),0)
$(error Sorry, this makefile is not intended to be \
used directly. Please use the makefile in the toplevel \
directory of the PUMA source tree instead)
endif

#-------------------------------------------------
# variables 
#-------------------------------------------------

AGXX    ?= $(subst ac++,ag++,$(AC))

include $(ROOT)/vars.mk

#-------------------------------------------------
# rules
#-------------------------------------------------

all: weave compile

weave: dirs config step1 step2

compile: dirs step3

dirs:
	@mkdir -p $(OBJDIR)
	@mkdir -p $(INCDIR)
	@mkdir -p $(STEP1)/src
	@mkdir -p $(STEP1)/dep
	@mkdir -p $(STEP1)/aspects
	@mkdir -p $(STEP1)/inc/Puma
	@mkdir -p $(STEP2)/src
	@mkdir -p $(STEP2)/dep
	@mkdir -p $(STEP2)/inc/Puma

config:
	@echo "Creating config file..."
	@mkdir -p $(dir $(CONFIG))
	@$(AGXX) --gen_config --c_compiler $(CXX) -o $(CONFIG)

step1: 
	@echo "Generating..."
	@$(MAKE) -f generate.mk

step2: 
	@echo "Weaving..."
	@$(MAKE) -f weave.mk

step3: 
	@echo "Compiling..."
	@$(MAKE) -f compile.mk

clean:
	@echo "Making sources clean..."
	@rm -rf $(GENDIR)

distclean: 
	@echo "Removing library, headers, and other generated files..."
	@rm -rf $(LIBDIR) $(INCDIR) $(ROOT)/gen-*


#-------------------------------------------------
# targets
#-------------------------------------------------

.PHONY: all clean dirs weave compile

=== Puma/tools/Makefile ===
#-------------------------------------------------
# variables 
#-------------------------------------------------

SUBDIRS := $(shell find $(shell pwd) -maxdepth 1 -mindepth 1 -type d)
SUBDIRS := $(filter-out %/CVS %/scripts, $(SUBDIRS))
SUBDIRS := $(SUBDIRS)

ifeq ($(SUBDIRS),)

define propagate
endef

else

# define how to propagate a target into the subdirectories
define propagate
	for DIR in $(SUBDIRS); \
	  do cd $$DIR; \
	  $(MAKE) -s $(MAKECMDGOALS); \
	done
endef

endif

#-------------------------------------------------
# rules
#-------------------------------------------------

all clean:
	@$(propagate)

=== AspectC++/examples/CFlow/Makefile ===
CXX ?= g++

cflow: main.cc
	$(CXX) $(CXXFLAGS) -o cflow main.cc

=== AspectC++/examples/IconCache/Makefile ===
CXX ?= g++

icon: main.cc IconCache.cc
	$(CXX) $(CXXFLAGS) -o icon main.cc IconCache.cc

=== AspectC++/examples/Instances/Makefile ===
CXX ?= g++

instances: main.cc
	$(CXX) $(CXXFLAGS) -o instances main.cc

=== AspectC++/examples/ObserverPattern/Makefile ===
CXX ?= g++

observer_pattern: AnalogClock.cc DigitalClock.cc ClockTimer.cc main.cc ac_gen.cc
	$(CXX) $(CXXFLAGS) -o $@ AnalogClock.cc DigitalClock.cc ClockTimer.cc main.cc ac_gen.cc

=== AspectC++/tests/Bug209/Makefile ===
ACFLAGS ?= --real-instances
include ../Makefile.generic

## aspectc++ 1.0

=== AspectC++/Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # libxml2 settings
 ifeq ($(_TARGET),win32)
 	LIBXML2_INC := `mingw32-xml2-config --cflags` 
-	LIBXML2_LIB := `mingw32-xml2-config --libs` -lwsock32
+	LIBXML2_LIB := `mingw32-xml2-config --libs`
 	EXT=.exe
 else
 	LIBXML2_INC := `xml2-config --cflags` 
@@ -31,6 +31,8 @@
 ifneq ($(SHARED),)
 	LDFLAGS += -Wl,-Bdynamic
 endif
+else
+	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lPuma
 endif
 
 LDFLAGS += $(LIBXML2_LIB)
@@ -50,6 +52,11 @@
 	CXXFLAGS += -pg
 endif
 
+# use the new libacmodel
+ifneq ($(ACMODEL),)
+  CPPFLAGS += -DACMODEL -I$(ACMODEL)/include
+	LDFLAGS  += -L$(ACMODEL)/lib/$(TARGET) -lacmodel 
+endif
 
 
 
@@ -82,10 +89,9 @@
 MAKE ?= make
 
 # ac++ settings for tests
-ACFLAGS := -v 9
-
-ACEXAMPLES = FigureObserver Instances Trace CFlow ID Action Cache IconCache \
-	     Order
+ACFLAGS := -k -v 9
+
+ACEXAMPLES = coverage helloworld modules profiling singleton
 
 
 .PHONY: $(ACEXAMPLES) 
@@ -96,6 +102,9 @@
 # ******************************
 
 all: showtarget dirs $(PROG)
+
+strip: $(PROG)
+	@$(STRIP) $<
 
 showtarget:
 	@echo "---"
@@ -111,6 +120,8 @@
 	@echo Making it clean.
 	@rm -rf  core core.* *~ $(PROG) $(OBJECTDIR) $(DEPDIR) $(ERROR_FILE)
 
+cleanall:	doxygen-clean clean
+
 dirs: $(DIRS)
 
 test: $(PROG)$(EXT) testall
@@ -123,8 +134,25 @@
 	@rm -rf examples/*-out
 	@rm -rf examples/*.acp
 
-.PHONY: all test  clean  example  examplerun  exampleclean \
-        showtarget
+doxygen:
+	@echo "Making AspectC++ documentation with doxygen"
+	@doxygen doc/doxygen.conf && echo "=> see doc/doxygen/html/index.html"
+
+doxygen-clean:
+	@rm -rf doc/doxygen
+
+regressiontest:
+	rm -rf RegressionTests.tar.bz2 RegressionTestsTmp
+	mkdir RegressionTestsTmp
+	svn export tests/ RegressionTestsTmp/tests/
+	sed -i '1iMAKELEVEL=1' RegressionTestsTmp/tests/Makefile
+	cd RegressionTestsTmp && tar cvfj RegressionTests.tar.bz2 tests/
+	mv RegressionTestsTmp/RegressionTests.tar.bz2 .
+	cd ..
+	rm -rf RegressionTestsTmp
+
+.PHONY: all test clean cleanall example examplerun exampleclean \
+        showtarget doxygen doxygen-clean

=== Puma/Makefile ===
#-------------------------------------------------
# variables 
#-------------------------------------------------

ROOT    ?= $(shell pwd)
TARGET  ?= linux-release
AC      ?= ac++
PREFIX  ?= /usr/local 
MINUSJ  ?= 1 

include vars.mk
include files.mk

LIBDIR  := $(ROOT)/lib/$(TARGET)
GENDIR  := $(ROOT)/gen-$(RELEASE)

INCDIR  := $(ROOT)/include
OBJDIR  := $(GENDIR)/obj-$(_TARGET)
STEP1   := $(GENDIR)/step1
STEP2   := $(GENDIR)/step2

CONFIG  := $(GENDIR)/puma.cfg
ACNEWREPO ?= $(GENDIR)/acpp.repo

# exported variables
export GENDIR INCDIR LIBDIR OBJDIR STEP1 STEP2
export ROOT TARGET AC DONTWEAVE CONFIG MINUSJ ACNEWREPO
export ORASOURCES LEMSOURCES SOURCES CSOURCES ASPECTS 

# suppress reporting directory changes
MAKE := $(MAKE) --no-print-directory

#-------------------------------------------------
# rules
#-------------------------------------------------

all: showinfo src

weave: showinfo src

compile: showinfo src

showinfo:
	@echo 
	@echo "---"
	@echo "Making PUMA for TARGET=$(TARGET)"
	@echo "  Extensions = $(EXTENSIONS)"
	@echo "---"
	@echo 

tools:
	@cd $(ROOT)/tools && $(MAKE)

src: tools
	@cd $(ROOT)/src && $(MAKE) $(MAKECMDGOALS)

examples: src
	@cd $(ROOT)/examples && $(MAKE)

doc:
	@echo "Generating Puma reference manual..."
	@doxygen doc/RefMan/doxygen.conf && echo "=> see doc/RefMan/html/index.html"

install: src
	@echo "Installing library and headers..."
	@mkdir -p $(PREFIX)/lib
	@cp -pv $(LIBDIR)/libPuma.* $(PREFIX)/lib
	@mkdir -p $(PREFIX)/include/Puma
	@cp -pv $(INCDIR)/Puma/*.*h $(PREFIX)/include/Puma

uninstall: 
	@echo "Uninstalling library and headers..."
	@rm -fv $(PREFIX)/lib/libPuma.*
	@rm -rfv $(PREFIX)/include/Puma

clean: tools-clean
	@cd $(ROOT)/src && $(MAKE) clean

tools-clean:
	@cd $(ROOT)/tools && $(MAKE) -s clean

examples-clean:
	@cd $(ROOT)/examples && $(MAKE) -s clean

docs-clean:
	@echo "Making docs clean..."
	@rm -rf $(ROOT)/doc/RefMan/html

cleanall: test-clean examples-clean tools-clean docs-clean
	@echo "Making completely clean..."
	@rm -rf $(ROOT)/lib
	@rm -rf $(ROOT)/gen-*

distclean: clean examples-clean docs-clean
	@cd $(ROOT)/src && $(MAKE) distclean

libclean:
	@echo "Removing library and object files..."
	@rm -f $(LIBDIR)/libPuma.*
	@rm -rf $(OBJDIR)
	@rm -rf $(STEP2)/dep

test: test-all

test-%:
	@echo "Making tests $*..."
	@$(MAKE) -C tests -s $*

#-------------------------------------------------
# targets
#-------------------------------------------------

.PHONY: all tools src install examples distclean cleanall \
clean tools-clean examples-clean libclean weave compile uninstall doc

=== AspectC++/tests/Makefile ===
--- 
+++ 
@@ -4,19 +4,25 @@
 directory of the ApectC++ source tree instead)
 endif
 
+SHELL=/bin/bash
+
 ACTESTS = Advice AdviceVirtualFct That StaticTrace Context NameMangling \
           Forward StandAloneCalls UnknownTypeCheck AccessControl Result \
           ArrayMangling MatchExpr ConsDesAdvice NestedClassFuncAdvice \
           MacroCall CallAdvice CallOnRef TemplateExtCall Bug190 Bug191 Bug192 \
-	  Order NonInlineIntros JPType PragmaOnce Bug207 Bug209 \
+	  Order NonInlineIntros JPType PragmaOnce Bug207 \
 	  AbstractDerivedAspect PragmaOnceObserver ThatConst PrivateResult \
           VoidArg ArrayWrapper Bug216 Bug228 ExecAdviceRecursive ExternC \
 	  ThatContext IntroIncludes Bug234 Bug234-2 Bug235 Bug239 \
-	  ExecAdviceNewDelete CallPostfixOp STLString CFlowCycle \
+	  ExecAdviceNewDelete ExecAdviceFriend CallPostfixOp STLString \
+	  CFlowCycle Bug368 \
 	  IntroInBase NonInlineIntroInclude Bug267 Bug268 Bug271 MatchVirtual \
 	  PctInClass IntroInAll Instantiation Slice NonInlineSliceInclude \
-	  Empty \
+	  Empty Bug316 Derived Base Bug323 GlobalIds AnonymousStuff \
+	  ForcedInclude Bug336 Bug353 Introspection CallAccess Bug418 \
 	  RepoInvalid RepoVersion
+
+# Doesn't work at the moment: Bug209
 
 ACMSGTESTS := RepoInvalid RepoVersion

=== debian/changelog ===
aspectc++ (1:1.0-4) unstable; urgency=low

  * debian/rules: Build doxygen in binary-arch target until buildds call the
    build-arch target instead of build to avoid FTBFS.

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 30 Jun 2011 21:11:23 +0200

aspectc++ (1:1.0-3) unstable; urgency=low

  * Don't compress examples files
  * Install into correct paths
  * add notes for linking against libPuma.a
  * Don't install non-functional Makefiles in example directories
  * Drop -no-rtti and from CFLAGS
  * implement build-arch and build-indep target as suggested by debian policy
  * Honor 'nocheck' flag in DEB_BUILD_OPTIONS

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 30 Jun 2011 17:29:15 +0200

aspectc++ (1:1.0-2) unstable; urgency=low

  * apply patch from upstream to fix FTBFS on kFreeBSD
  * simplify Vcs-Bzr field

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 19 Apr 2011 21:59:07 +0200

aspectc++ (1:1.0-1) unstable; urgency=low

  * New upstream version
  * don't ignore errors in maintainer scripts
  * aspectc++.postinst: don't call ag++ with full path
  * prefer dh_prep over dh_clean -k
  * Add ${misc:Depends} dependencies
  * support parallel builds
  * bump standards version
  * bump debhelper compat level to 7
  * install all Puma samples
  * switch to source format 3.0 (quilt)
  
 -- Reinhard Tartler <siretart@tauware.de>  Mon, 18 Apr 2011 21:40:56 +0200

aspectc++ (1.0pre4~svn.20080711-1) unstable; urgency=low

  * new upstream snapshot.
  * include all upstream documentation. Clarifying emails regarding
    licensing has been included into debian/copyright.
  * reformat description following recomendations of
    http://www.debian.org/doc/debian-policy/ch-controlfields.html#s-f-Description
    (Closes: #480316)

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 07 Jul 2008 14:41:02 +0200

aspectc++ (1.0pre4~svn.20080409+dfsg-3) unstable; urgency=low

  * Fix another missing include, this time in Ag++/StdSystem.cc

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 10 Apr 2008 17:40:52 +0200

aspectc++ (1.0pre4~svn.20080409+dfsg-2) unstable; urgency=low

  * After another round of reviewing Bens diff, the NMU was correct after
    all.  Incorporating the Ppatch from
    http://bugs.debian.org/cgi-bin/bugreport.cgi?msg=23;bug=417489
    Really Closes: #417489 this time.
  * reweave Puma with changes from previous change.
  * More cleanups in the Puma buildscripts: debian/rules honors now noopt in
    the variable DEB_BUILD_OPTIONS.
  * add Vcs-Bzr headers to debian/control.

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 10 Apr 2008 13:37:36 +0200

aspectc++ (1.0pre4~svn.20080409+dfsg-1) unstable; urgency=low

  * new upstream snapshot
    - now builds properly with GCC 4.3 (Closes: #417489, #424106)
    - uses bash in the ag++ testsuite (Closes: #373665)
    - explicitly not ACKing NMU from Ben Hutchings. Upstream has fixed
      the issues with GCC 4.3 independently
    - Now shipping prewoven puma sources directly in the orig.tar.gz (again)
    - remove unlicensed documentation.
  * bumbed standards version
  * use CURDIR instead of PWD, thanks lintian
  * updated maintainer record
  * add script and target for retrieving a clean upstream tarball
  * Incorporating and Acking NMU from Sandro Tosi. (Closes: #424106)
  * compile ac++ twice: one time with prewoven Puma, then reweave a copy
    of Puma, then build a new ac++ with the freshly woven Puma. This
    ensures that ac++ is actually able to compile itself (Closes: #474560)
  * ensure that the AspectC++ testsuite is using /bin/bash (Closes: #373665)
  * compile with -O2 instead of -O3. -O2 is likely to cause problems on
    non-mainstream architectures. Plus, add '-g' to compilation flags, so
    that a build with DEB_BUILD_OPTIONS='noopt' actually creates a package
    with debugging information.
  * add dependency on gsfonts for having proper fonts in the doxygen
    outputs.
  * Bump Standard version to 3.7.3 (no changes needed).
  * Use Homepage Field.
  * Move packages into correct sections: libpuma-doc -> doc,
    libpuma-dev -> libdevel.
  * simplify debian/rules a bit.
  * install (woven) Puma development headers into libpuma-dev.

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 10 Apr 2008 09:23:51 +0200

aspectc++ (0.99+1.0pre3-3.1) unstable; urgency=low

  * Non-maintainer upload

  [ Sandro Tosi ]
  * debian/rules
    - added removal of binary not cleaned (Closes: #424106)

  [ Ben Hutchings ]
  * Fixed recursive make invocations to avoid hiding failures
  * Added/changed #include and using directives for g++ 4.3
    (Closes: #417489) (partly by Martin Michlmayr)
  * Added missing parentheses in Puma::FilenameInfo::name()

 -- Ben Hutchings <ben@decadent.org.uk>  Sun, 06 Apr 2008 01:15:28 +0100

aspectc++ (0.99+1.0pre3-3) experimental; urgency=low

  * more cleanups in Puma/Makefile
  * removed Antonio from uploaders on his request. Thank you for your work!
  * bumped standards version to 3.7.2 (no changes needed)
  * Introduce new package: libpuma-dev, for direct use of the
    puma library (Closes: #369771)
  * Introduce new package: libpuma-doc, with updated doxygen.conf
    containing 2 examples (ccparser and cparser) and doxygen generated docs
  * Added circular build-depend on itself, testing if the ac++ binary is
    working on all architectures!
  * Merge patches from upstream for ag++, fixing command line handling and
    fixes in the testsuite.

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 12 Jun 2006 10:53:28 +0200

aspectc++ (0.99+1.0pre3-2ubuntu2) gutsy; urgency=low

  * Rebuild to deal with launchpad looping.

 -- LaMont Jones <lamont@ubuntu.com>  Thu, 11 Oct 2007 21:28:50 -0600

aspectc++ (0.99+1.0pre3-2ubuntu1) feisty; urgency=low

  * Rebuild for ldbl128 change (powerpc, sparc).
  * Set Ubuntu maintainer address.

 -- Matthias Klose <doko@ubuntu.com>  Thu,  1 Mar 2007 22:30:19 +0000

aspectc++ (0.99+1.0pre3-2) unstable; urgency=low



=== debian/control ===
Source: aspectc++
Section: devel
Priority: optional
Maintainer: Reinhard Tartler <siretart@tauware.de>
Build-Depends: debhelper (>= 7.0.0), libxml2-dev, docbook-to-man
Build-Depends-Indep: doxygen, graphviz, gsfonts
Standards-Version: 3.9.2
Homepage: http://www.aspectc.org
Vcs-Bzr: http://code.launchpad.net/~siretart/aspectc++/debian

Package: aspectc++
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, g++
Description: aspect-oriented programming extension for C++
 AspectC++ supports Aspect-Oriented Programming with C++, by providing:
 .
  - an aspect language extension to C++.
  - an aspect weaver that does source-to-source translation.
 .
 AspectC++ provides for C++ similar features like its best known
 cousin, AspectJ, provides for Java.

Package: libpuma-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Suggests: libpuma-doc
Description: C/C++/AspectC++ Scanner and Parsers
 libPuma is a library written in C++ for Scanning and Parsing C++
 Code. It also does some semantic analysis.
 .
 It was written to faciliate the development for tools, which manipulate
 and/or transfor C/C++ Code.
 .
 This package ships a static copy of libPuma only.

Package: libpuma-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: C/C++/AspectC++ Scanner and Parsers
 libPuma is a library written in C++ for Scanning and Parsing C++
 Code. It also does some semantic analysis.
 .
 It was written to faciliate the development for tools, which manipulate
 and/or transfor C/C++ Code.
 .
 This package ships doxygen generated documentation for Puma.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Support multiple makes at once
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NUMJOBS := 1
# on i386 and amd64, we query the system unless overriden by DEB_BUILD_OPTIONS
ifeq      ($(DEB_HOST_ARCH),i386)
NUMJOBS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
else ifeq ($(DEB_HOST_ARCH),amd64)
NUMJOBS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
endif
endif


ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS := -Wall -O0 -g
else
	CFLAGS := -Wall -O2 -g
endif
export CFLAGS
PUMA_CONFIG=$(CURDIR)/puma.config

test-builds: build-arch-stamp
	Ag++/bin/linux-release/ag++ --gen_config
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C AspectC++/ SHARED=1 PUMA_CONFIG=$(PUMA_CONFIG) test
	PATH=$(CURDIR)/AspectC++/bin/linux-release:$(PATH) \
	$(MAKE) -C Ag++/      SHARED=1 PUMA_CONFIG=$(PUMA_CONFIG) test
endif

build: build-arch-stamp test-builds
build-arch-stamp:
	dh_testdir
	# save a copy of Puma that will be woven later
	cp -r Puma Puma.copy
	$(MAKE) -C Puma/      EXTENSIONS="acppext gnuext winext" compile MINUSJ=$(NUMJOBS)
	$(MAKE) -C AspectC++/ SHARED=1 -j$(NUMJOBS) all
	$(MAKE) -C Ag++/      SHARED=1 -j$(NUMJOBS) all
	# ok, now we have both an ac++ binary and ag++ binary
	# now let's weave Puma again in the copy
	$(MAKE) -C Puma.copy clean
	$(MAKE) -C Puma.copy all AC=$(CURDIR)/AspectC++/bin/linux-release/ac++ MINUSJ=$(NUMJOBS) EXTENSIONS="acppext gnuext winext"
	# let's clean and compile ac++ and ag++ again with new Puma
	$(MAKE) -C AspectC++ clean
	$(MAKE) -C Ag++      clean
	$(MAKE) -C AspectC++ SHARED=1 Puma=$(CURDIR)/Puma.copy -j$(NUMJOBS) all
	$(MAKE) -C Ag++      SHARED=1 Puma=$(CURDIR)/Puma.copy -j$(NUMJOBS) all

	# build manpages:
	docbook-to-man debian/ac++.1.sgml > ac++.1
	docbook-to-man debian/ag++.1.sgml > ag++.1
	# mark timestamp
	touch $@

build-indep: build-indep-stamp
build-indep-stamp:
	dh_testdir
	$(MAKE) -C Puma doc
	touch $@

clean:
	dh_testdir
	dh_testroot
	dh_clean build-*stamp binary-*stamp puma.config
	# cleaning up source directories:
	$(MAKE) -s -C Puma libclean
	$(MAKE) -s -C Puma tools-clean
	$(MAKE) -s -C Puma docs-clean
	$(MAKE) -s -C Puma examples-clean
	$(MAKE) -s -C AspectC++ clean
	$(MAKE) -s -C Ag++ clean
	# remove leftovers from Upstream Makefiles
	rm -rf AspectC++/tests/RepoVersion/repo.use
	rm -rf Ag++/DepFiles Ag++/ObjFiles Ag++/bin Ag++/tests/test_11.config
	rm -rf AspectC++/DepFiles AspectC++/ObjFiles AspectC++/bin
	rm -rf AspectC++/tests/*/feature.out
	# remove generated manpages:
	rm -f ac++.1 ag++.1
	rm -rf AspectC++/bin
	rm -rf Puma.copy/
	# standard cleaning:
	dh_clean

# Build architecture-independent files here.
binary-indep: build-indep
	dh_testdir
	dh_testroot
	dh_prep
	dh_installchangelogs
	dh_installdocs -p libpuma-doc Puma/doc/RefMan/html
	dh_installexamples -p libpuma-doc Puma/examples/*
	dh_compress -X.cc -X.map
	dh_fixperms
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	dh_installchangelogs
	dh_installdocs
	dh_install
	dh_installexamples -p aspectc++ AspectC++/examples/*
	find debian/aspectc++ -name Makefile -exec rm -v {} +
	find debian/libpuma-doc -name Makefile -exec rm -v {} +
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build build-indep build-arch clean binary-indep binary-arch binary

## aspectc++ 1.0pre4~svn.20080409+dfsg

=== Puma/Makefile ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #-------------------------------------------------
 # variables 
 #-------------------------------------------------
+
+include files.mk
 
 ROOT    ?= $(shell pwd)
 TARGET  ?= linux-release
@@ -9,7 +11,6 @@
 MINUSJ  ?= 1 
 
 include vars.mk
-include files.mk
 
 LIBDIR  := $(ROOT)/lib/$(TARGET)
 GENDIR  := $(ROOT)/gen-$(RELEASE)
@@ -20,12 +21,11 @@
 STEP2   := $(GENDIR)/step2
 
 CONFIG  := $(GENDIR)/puma.cfg
-ACNEWREPO ?= $(GENDIR)/acpp.repo
 
 # exported variables
 export GENDIR INCDIR LIBDIR OBJDIR STEP1 STEP2
-export ROOT TARGET AC DONTWEAVE CONFIG MINUSJ ACNEWREPO
-export ORASOURCES LEMSOURCES SOURCES CSOURCES ASPECTS 
+export ROOT TARGET AC DONTWEAVE CONFIG MINUSJ
+export ORASOURCES LEMSOURCES SOURCES ASPECTS 
 
 # suppress reporting directory changes
 MAKE := $(MAKE) --no-print-directory
@@ -49,17 +49,20 @@
 	@echo 
 
 tools:
+	@echo "Making tools..."
 	@cd $(ROOT)/tools && $(MAKE)
 
 src: tools
+	@echo "Making library..."
 	@cd $(ROOT)/src && $(MAKE) $(MAKECMDGOALS)
 
 examples: src
+	@echo "Making examples..."
 	@cd $(ROOT)/examples && $(MAKE)
 
-doc:
-	@echo "Generating Puma reference manual..."
-	@doxygen doc/RefMan/doxygen.conf && echo "=> see doc/RefMan/html/index.html"
+doxygen:
+	@echo "Making Puma documentation with doxygen..."
+	@doxygen doc/doxygen.conf && echo "=> see doc/doxygen/html/index.html"
 
 install: src
 	@echo "Installing library and headers..."
@@ -77,14 +80,16 @@
 	@cd $(ROOT)/src && $(MAKE) clean
 
 tools-clean:
+	@echo "Making tools clean..."
 	@cd $(ROOT)/tools && $(MAKE) -s clean
 
 examples-clean:
+	@echo "Making examples clean..."
 	@cd $(ROOT)/examples && $(MAKE) -s clean
 
 docs-clean:
 	@echo "Making docs clean..."
-	@rm -rf $(ROOT)/doc/RefMan/html
+	@rm -rf $(ROOT)/doc/doxygen
 
 cleanall: test-clean examples-clean tools-clean docs-clean
 	@echo "Making completely clean..."
@@ -111,4 +116,4 @@
 #-------------------------------------------------
 
 .PHONY: all tools src install examples distclean cleanall \
-clean tools-clean examples-clean libclean weave compile uninstall doc
+clean tools-clean examples-clean libclean weave compile uninstall

=== AspectC++/tests/Makefile ===
--- 
+++ 
@@ -3,8 +3,6 @@
 used directly. Please use the makefile in the toplevel \
 directory of the ApectC++ source tree instead)
 endif
-
-SHELL=/bin/bash
 
 ACTESTS = Advice AdviceVirtualFct That StaticTrace Context NameMangling \
           Forward StandAloneCalls UnknownTypeCheck AccessControl Result \
@@ -14,12 +12,11 @@
 	  AbstractDerivedAspect PragmaOnceObserver ThatConst PrivateResult \
           VoidArg ArrayWrapper Bug216 Bug228 ExecAdviceRecursive ExternC \
 	  ThatContext IntroIncludes Bug234 Bug234-2 Bug235 Bug239 \
-	  ExecAdviceNewDelete ExecAdviceFriend CallPostfixOp STLString \
-	  CFlowCycle Bug368 \
+	  ExecAdviceNewDelete CallPostfixOp STLString CFlowCycle \
 	  IntroInBase NonInlineIntroInclude Bug267 Bug268 Bug271 MatchVirtual \
 	  PctInClass IntroInAll Instantiation Slice NonInlineSliceInclude \
 	  Empty Bug316 Derived Base Bug323 GlobalIds AnonymousStuff \
-	  ForcedInclude Bug336 Bug353 Introspection CallAccess Bug418 \
+	  ForcedInclude Bug336 Bug353 \
 	  RepoInvalid RepoVersion
 
 # Doesn't work at the moment: Bug209

=== Puma/tests/Makefile ===
ifeq ($(MAKELEVEL),0)
$(error Sorry, this makefile is not intended to be \
used directly. Please use the makefile in the toplevel \
directory of the Puma source tree instead)
endif

TESTS = misc bug129 bug138 bug96 bug130 bug108 bug94 bug149 \
        bug164 bug153 bug166 bug156 bug180 bug182 bug320 bug344 \
        bug269 bug259 bug248 bug218 bug203 bug350 bug273 bug326 \
        bug332 bug340 bug339 bug337

# open bugs
OPEN = bug100 bug10 bug102 bug137 bug187 bug249 bug5 bug145 \
       bug188 bug342 bug61 bug189 bug338 \
       bug333 bug328 bug325 bug345 bug346 bug347 \
       bug303 bug289 bug287 bug275 bug348 bug343 bug274 \
       bug264 bug258 bug232 bug220

STDOUT_FILE := stdout.txt
STDERR_FILE := stderr.txt
ERROR_FILE  := error.txt

all: $(addsuffix .parse, $(TESTS))
	@if [ -f $(ERROR_FILE) ];then \
		echo -e "\n\n"; \
		echo "+---------+"; \
		echo "|ERRORS:  |"; \
		echo "+---------+"; \
		cat $(ERROR_FILE); \
	 else \
		echo -e "\n\n"; \
	 	echo "All tests OK"; \
	 fi;\
	 rm -f $(STDOUT_FILE) $(STDERR_FILE) $(ERROR_FILE)

ref:  $(addsuffix .ref, $(TESTS))

refclean:
	@rm -f */parse.ref

outclean:
	@rm -f */parse.out

clean: $(addsuffix .clean, $(TESTS))

%.parse: %
	@unset LANG; \
	exec 6>&1; \
	exec 7>&2; \
	exec >& $</parse.out; \
	$(MAKE) -s -C $< ; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	diff $</parse.out $</parse.ref; \
	RET=$$?; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo -n "."; \
	else \
		ERR_FLAG=D; \
	 	echo -n "[$$ERR_FLAG:$<]"; \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo  -n "TEST: $<" >> $(ERROR_FILE); \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo -e "STDOUT:\n--------" >> $(ERROR_FILE); \
		cat $(STDOUT_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
		echo -e "STDERR:\n--------" >> $(ERROR_FILE); \
		cat $(STDERR_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
	fi;

%.ref: %
	@$(MAKE) -s EXT="$(EXT)" -C $< ref; 

%.clean: %
	@cd $< && $(MAKE) clean

.PHONY: all clean ref
